#ifndef __LIBCFUNCS_H__
#define __LIBCFUNCS_H__

/* Mixing kernel header-files and GNU libc header files does not work,
 * so we define what we need from libc here
 */

#define EOF (-1)
typedef void *FILE;
extern FILE stdout, stdin, stderr;

extern int fprintf (FILE *, const char *format, ...)  __attribute__((format (printf, 2, 3)));
extern int fflush (FILE *);
extern int printf (const char *format, ...) __attribute__((format (printf, 1, 2)));
extern int vprintf(const char *format, va_list ap);

extern int open(const char *pathname, int flags);

extern int gettimeofday(struct timeval *tv, void *);
extern void *malloc(size_t size);
extern int errno;
extern int close(int fd);
extern void perror(const char *s);
extern ssize_t read(int fd, void *buf, size_t count);
extern int getopt(int argc, char * const argv[],
                  const char *optstring);
extern char *optarg;
extern int optind, opterr, optopt;
extern int fsync(int fd);
extern int toupper (int c);
extern int tolower (int c);
extern int atoi(const char *nptr);
extern FILE *fopen (const char *path, const char *mode);
extern int feof (FILE *stream);
extern size_t fread(void *ptr, size_t size, size_t nmemb, FILE *stream);
extern size_t fwrite(const void *ptr, size_t size, size_t nmemb, FILE *stream);
extern int fclose (FILE *stream);
extern int rand(void);

#undef strdup
extern char *strdup(const char *s);

#undef memset
extern void *memset(void *s, int c, size_t n);

#undef exit
extern void exit(int status);

#endif /* __LIBCFUNCS_H__ */
